import 'dart:async';

import 'package:flutter/services.dart';

class Logcat {
  static const MethodChannel _channel =
      const MethodChannel('logcat');
  static const platform = const MethodChannel('app.channel.logcat');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> execute() async {
    String logs;
    try {
      final String result = await platform.invokeMethod('execLogcat');
      logs = result;
    } on PlatformException catch (e) {
      logs = "Failed to get logs: '${e.message}'.";
    }

    return logs;
  }
}
